local frame = CreateFrame("FRAME", "VendorVisionFrame")
frame:RegisterEvent("QUEST_COMPLETE")
local function eventHandler(self, event, ...)
	local rewards = GetNumQuestChoices()
	if rewards == 0 then return end
	local bestPrice = 0
	local bestItem,rewardFrame
	for i=1,rewards do
		local itemLink = GetQuestItemLink("choice", i)
		local _,_,_,_,_,_,_,_,_,_,itemSellPrice = GetItemInfo(itemLink)
		if itemSellPrice > bestPrice then
			bestPrice = itemSellPrice
			bestItem = i
		end
	end

	if not bestItem then return end -- don't do anything if nothing is vendorable
	rewardFrame = getglobal("QuestInfoItem"..bestItem)
	if not rewardFrame.vendorvision then -- make a texture if one doesn't exist
		rewardFrame.vendorvision = rewardFrame:CreateTexture()
		rewardFrame.vendorvision:SetPoint("BOTTOMRIGHT",-127,3)
		rewardFrame.vendorvision:SetPoint("BOTTOMLEFT",3,3)
		rewardFrame.vendorvision:SetPoint("TOPLEFT",3,-21)
		rewardFrame.vendorvision:SetPoint("TOPRIGHT",-127,-21)
		rewardFrame.vendorvision:SetTexture("Interface\\Icons\\INV_Misc_Coin_01",0)
		rewardFrame.vendorvision:SetAlpha(0.8)
	else
		rewardFrame.vendorvision:Show() -- show the frame if it already exists
	end
end
frame:SetScript("OnEvent", eventHandler)

-- hook the quest hide function and also remove the icon
-- or else it shows up in the quest log
hooksecurefunc("CloseQuest", function(...)
	for i=1,MAX_NUM_ITEMS do
		local rewardFrame = getglobal("QuestInfoItem"..i)
		if rewardFrame.vendorvision then rewardFrame.vendorvision:Hide() end
	end
end)
